/***

*

*  FORCA.prg

*

*  Modulo Para Tratamento de Arquivos

*

*

*/



#include "common.ch"

#include "inkey.ch"



********************************

procedure FORCA



   clear screen

   clear gets

   close databases

   release all

   set wrap on

   set bell off

   set color to 

   setcursor(1)

   set console on

   set confirm on

   set date british

   set scoreboard off

   set delimiters off

   private _som, _erro, _nome, _word, _usad, _tenta, _forma

   apresenta()

   do while (.T.)

      SetColor("W/N", "N/W", "N", "N", "N/W")

      clear typeahead

      clear gets

      clear screen

      clear gets

      _erro:= 1

      _nome:= Space(15)

      _word:= Space(30)

      _usad:= ""

      monta(1)

      @  1, 45 to 24, 79 double

      @  3, 47 say "Quem entrara' na Forca ?"

      @  5, 47 say "Nome:" get _NOME picture "@!" valid !Empty(_nome)

      read

      if (LastKey() == K_ESC)

         if (pergunta("Finalizar ?  (S)im  ou  (N)ao"))

            exit

         endif

         loop

      endif

      @  2, 46 clear to 23, 78

      @  3, 47 say "Muito bem " + alltrim(_nome) + "..."

      @  5, 47 say "Vire-se para que seu oponente  "

      @  7, 47 say "digite uma palavra de ate' 30  "

      @  9, 47 say "letras, do qual voce tera' que "

      @ 11, 47 say "tentar adivinhar, sendo que,   "

      @ 13, 47 say "possuira' 6 chances para tal..."

      @ 16, 47 say "   *** B O A   S O R T E ***   "

      @ 23, 47 say " Tecla algo para continuar...  "

      InKey(0)

      set color to N/W

      @ 23, 15 say Space(17)

      @ 23, 24 - Len(alltrim(_nome)) / 2 say alltrim(_nome)

      SetColor("W/N", "N/W", "N", "N", "N/W")

      @  2, 46 clear to 23, 78

      @  3, 47 say "Digite palavra (ate' 30 letras)"

      @  5, 47 get _WORD picture "@!A" valid !Empty(_word)

      read

      if (LastKey() == K_ESC)

         if (pergunta("Finalizar ?  (S)im  ou  (N)ao"))

            exit

         endif

         loop

      endif

      _word:= alltrim(_word)

      _forma:= Replicate(".", Len(_word))

      @ 11, 47 say Replicate("-", Len(_word))

      do while (.T.)

         _tenta:= Space(1)

         @  2, 46 clear to 23, 78

         @  3, 47 say "Chances: " + Str(7 - _erro, 1)

         @  5, 47 say "Letras.: " + _usad

         @  9, 47 say "Palavra secreta:"

         @ 11, 47 say _forma

         @ 14, 47 say "Digite uma Letra:" get _TENTA picture "@!A" ;

            valid !Empty(_tenta)

         read

         if (LastKey() == K_ESC)

            if (pergunta("Cancela este Jogo ?  (S)im  ou  (N)ao"))

               exit

            endif

            loop

         endif

         if (_tenta $ _usad)

            msg("Voce ja' digitou esta letra...")

            loop

         endif

         _usad:= _usad + _tenta

         if (!secreta())

            _erro++

            monta(_erro)

         endif

         if (_erro == 7)

            preenche(.F.)

            exit

         endif

         if (_word = _forma)

            preenche(.T.)

            exit

         endif

      enddo

   enddo

   close databases

   release all

   clear screen

   clear gets

   quit



********************************

function APRESENTA



   private _lp

   _som:= .F.

   if (pergunta("Deseja Jogar com Som ?  (S)im  ou  (N)ao"))

      _som:= .T.

   endif

   setcursor(0)

   for _lp:= 1 to 7

      monta(_lp)

      InKey(0.2)

   next

   monta(8)

   InKey(5)

   setcursor(1)

   return Nil



********************************

function PERGUNTA



   parameters _tipo

   setcursor(0)

   msg(_tipo)

   if (LastKey() = 83 .OR. LastKey() = 115)

      return .T.

   endif

   setcursor(1)

   return .F.



********************************

function MSG



   parameters _mensag

   private _calc, _telmsg

   setcursor(0)

   if (_som)

      tone(900, 2)

      tone(500, 3)

   endif

   clear typeahead

   _telmsg:= SaveScreen(0, 0, 24, 79)

   set color to N/W

   _calc:= Len(alltrim(_mensag)) / 2

   @  8, 38 - (_calc + 1) to 12, 39 + (_calc + 1) double

   @  9, 38 - _calc clear to 11, 39 + _calc

   @ 10, 39 - _calc say _mensag

   InKey(0)

   SetColor("W/N", "N/W", "N", "N", "N/W")

   RestScreen(0, 0, 24, 79, _telmsg)

   setcursor(1)

   return Nil



********************************

function SECRETA



   private _velha, _pl

   _velha:= _forma

   if (!Empty(_usad))

      for _pl:= 1 to Len(_word)

         if (SubStr(_word, _pl, 1) = _tenta)

            _forma:= stuff(_forma, _pl, 1, _tenta)

         endif

      next

   endif

   if (_forma = _velha)

      return .F.

   endif

   if (_som)

      tone(2500, 1)

      tone(3000, 1)

   endif

   return .T.



********************************

function MONTA



   parameters _parte

   private _telmon

   do case

   case _parte = 1

      if (_som)

         tone(1000, 2)

      endif

      @  1,  1 say "###################################"

      @  2,  1 say "#    #                            #"

      @  3,  1 say "#   #"

      @  4,  1 say "#  #"

      @  5,  1 say "# #"

      @  6,  1 say "##"

      @  7,  1 say "#"

      @  8,  1 say "#"

      @  9,  1 say "#"

      @ 10,  1 say "#"

      @ 11,  1 say "#"

      @ 12,  1 say "#"

      @ 13,  1 say "#"

      @ 14,  1 say "#"

      @ 15,  1 say "#"

      @ 16,  1 say "#"

      @ 17,  1 say "#"

      @ 18,  1 say "#"

      @ 19,  1 say "##"

      @ 20,  1 say "# #"

      @ 21,  1 say "#  #"

      @ 22,  1 say "#   #       #####################"

      @ 23,  1 say "#    #      #                   #"

      @ 24,  1 say "##########################################"

   case _parte = 2

      if (_som)

         tone(1100, 2)

      endif

      @  3, 20 say " .---. "

      @  4, 20 say "| . . |"

      @  5, 20 say "|    |"

      @  6, 20 say " | v | "

      @  7, 20 say " `---' "

   case _parte = 3

      if (_som)

         tone(1200, 2)

      endif

      @  8, 18 say "---'`---"

      @  9, 18 say "_         _"

      @ 10, 18 say " |       | "

      @ 11, 18 say " |       | "

      @ 12, 18 say " |       | "

      @ 13, 18 say " `======' "

   case _parte = 4

      if (_som)

         tone(1300, 2)

      endif

      @ 14, 16 say "   |       |   "

      @ 15, 16 say "   |   -   |   "

      @ 16, 16 say "   |  | |  |   "

      @ 17, 16 say "   |  | |  |   "

      @ 18, 16 say "   |  | |  |   "

      @ 19, 16 say "   |  | |  |   "

      @ 20, 16 say ".--'  | |  `--."

      @ 21, 16 say "|_____| |_____|"

   case _parte = 5

      if (_som)

         tone(1400, 2)

      endif

      @  8, 15 say ".--"

      @  9, 15 say "|  "

      @ 10, 15 say "| |"

      @ 11, 15 say "| |"

      @ 12, 15 say "| |"

      @ 13, 15 say "| |"

      @ 14, 15 say "|||"

      @  8, 29 say "--."

      @  9, 29 say "  |"

      @ 10, 29 say "| |"

      @ 11, 29 say "| |"

      @ 12, 29 say "| |"

      @ 13, 29 say "| |"

      @ 14, 29 say "|||"

   case _parte = 6

      if (_som)

         tone(1500, 2)

      endif

      @  2, 19 say "@"

      @  3, 19 say "@"

      @  4, 19 say "@"

      @  5, 19 say "@"

      @  6, 19 say "@"

      @  7, 19 say " @"

      @  8, 19 say "--@@@@@"

      @  6, 23 say "-"

   case _parte = 7

      if (_som)

         tone(1600, 2)

      endif

      _telmon:= SaveScreen(2, 15, 21, 31)

      @  2, 13 clear to 23, 33

      @  2, 19 say "@"

      RestScreen(3, 15, 22, 31, _telmon)

      @  5, 22 say "+ +"

      @  7, 23 say "^"

   case _parte = 8

      if (_som)

         tone(1700, 2)

      endif

      set color to N/W

      @  5, 43 say "  * * * * * * * * * * * * * * * * *  "

      @  6, 43 say " *                                 * "

      @  7, 43 say "*            F O R C A              *"

      @  8, 43 say "*            ---------              *"

      @  9, 43 say "*                                   *"

      @ 10, 43 say "*  Por: EDILSON MENDES NASCIMENTO   *"

      @ 11, 43 say "*                                   *"

      @ 12, 43 say "*                                   *"

      @ 13, 43 say "*                                   *"

      @ 14, 43 say "*              FORCA                *"

      @ 15, 43 say "*                                   *"

      @ 16, 43 say "*                                   *"

      @ 17, 43 say " *                                 * "

      @ 18, 43 say "  * * * * * * * * * * * * * * * * *  "

      SetColor("W/N", "N/W", "N", "N", "N/W")

   endcase

   return Nil



********************************

function PREENCHE



   parameters _flag

   private _lin

   clear gets

   clear typeahead

   setcursor(0)

   set color to N/W

   @ 11, 47 say _word

   SetColor("W/N", "N/W", "N", "N", "N/W")

   @ 12, 46 clear to 23, 78

   @ 13, 45 say "" + Replicate("", 33) + ""

   for _lin:= 14 to 23

      if (!_flag)

         if (_som)

            tone(2000 + 10 * _lin, 2)

         endif

         @  3, 56 say "0"

         @ _lin, 47 say "****** E N F O R C A D O ******"

      else

         if (_som)

            tone(3000 + 10 * _lin, 2)

         endif

         @ _lin, 47 say "******* P A R A B  N S *******"

      endif

   next

   InKey(10)

   setcursor(1)

   return Nil



* EOF

